/*
 * A0B36PRI_091026_05  "PROGRAMOVANI"  08.07.2009 
 *   
 * Prednaska 05 - proceduralni programovani
 *
 * Formatovana tabulka fce sinus(x)
 * 
 */

package a0b36pri_091026_05;

public class X05a {//=========================================================

    ////////////////////////////////////////////////////////////////////////////
    public static void main(String[] args) {//////////////////////////////
        final double pocUhel=0;
        final double krokFce=2;
        final int sloupcuTab=5;
        final int radkuTab=4;
        Io.writeLn("==X05a==");
        if(! tabSin(pocUhel,krokFce,sloupcuTab,radkuTab)){
            Io.writeLn("Error: vstupni parametry");
        }
         Io.writeLn("==X05a END==");
    }// main() END /////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    
    ////////////////////////////////////////////////////////////////////////////
    // Zadani:
    // Vstup:
    //      Tabulka fce sin, poc. uhel (stupnu), krok (stupnu),
    //      max 6 sloupcu 10 radku, hlavicka tabulky
    // Vystup:
    //      ok/error
    static boolean tabSin (double pocUhel, double krokFce, int sloupcuTab, int radkuTab){
        boolean vysledek=true;
        final int mistMantisy=2;
        final int mistCharakteristiky=2;
        final int sirkaTab=sloupcuTab*(3+1+1+1+mistMantisy+1+1+mistCharakteristiky);
        // Struktura funkce:
        // kontrola vstupnich parametru
        // prepocet stupnu na radiany
        // tisk hlavicky
        // tisk tabulky funkce

        // kontrola vstupnich parametru
        while(true){
            if(sloupcuTab > 6 || radkuTab > 10){
                vysledek = false;
                break;
            }
        // prepocet stupnu na radiany
        pocUhel = (2*Math.PI/360)*pocUhel;
        krokFce = (2*Math.PI/360)*krokFce;
        // tisk hlavicky (doplnit pozdeji)
        ramTab(sirkaTab);
        hlavickaTab("Funkce Sinus",sirkaTab);
        ramTab(sirkaTab);
        // tisk tabulky
        for(int i = 0; i < radkuTab; i++){
            for(int j = 0; j < sloupcuTab; j++){
                Io.write(" | ");
                Io.write(Math.sin(pocUhel),mistMantisy,mistCharakteristiky);
                pocUhel = pocUhel + krokFce;
            }// vnitrni for() END
            Io.writeLn(" |");
        }// vnejsi for() END
        ramTab(sirkaTab);
        break;    
        }// while() END
        return (vysledek);
    }// tabSin() END ///////////////////////////////////////////////////////////
    
    static void ramTab (int sirkaTab){//////////////////////////////////////////
       Io.write(" |");
        for(int i = 0; i < (sirkaTab-2); i++)
            Io.write("-");
        Io.write("-|\n");
    }// ramTab() END ///////////////////////////////////////////////////////////
    
    static void hlavickaTab (String nadpisTab, int sirkaTab){///////////////////
        if(nadpisTab.length() > sirkaTab-5) return;
        Io.write(" | " + nadpisTab);
        for(int i = 0; i < (sirkaTab - nadpisTab.length() - 2); i++)
            Io.write(" ");
        Io.writeLn("|");
    }// hlavickaTab() END //////////////////////////////////////////////////////

    
}// X05a class END
