/*
 * A0B36PRI_091026_05  "PROGRAMOVANI"  08.07.2009 
 *   
 * Prednaska 05 - proceduralni programovani
 *
 * Formatovana tabulka funkci s moznosti doplneni dalsich funkci.
 * 
 */

package a0b36pri_091026_05;

public class X05b {//==========================================================
 
    ////////////////////////////////////////////////////////////////////////////
    public static void main(String[] args) {////////////////////////////////////
       // Jen lokalni promenne
        final int SIN=1;
        final int COS=2;
        final int SLOUPCU=5;
        final int RADKU=6;
        final String NADPIS_SINUS="Funkce SINUS";
        final String NADPIS_COSINUS="Funkce COSINUS";
        final int MIST_MANTIS=3;
        final int MIST_CHARAKT=2;
        final int POC_UHEL=0;
        final int KROK_UHLU=90;

        Io.writeLn("==X05b==");
        
        tabFceInit(SIN,POC_UHEL,KROK_UHLU);
        tabFormat(NADPIS_SINUS,SLOUPCU,RADKU,MIST_MANTIS,MIST_CHARAKT);
        
        tabFceInit(COS,POC_UHEL,KROK_UHLU);
        tabFormat(NADPIS_COSINUS,SLOUPCU-1,RADKU,MIST_MANTIS,MIST_CHARAKT);
        
        tabFceInit(0,POC_UHEL,KROK_UHLU);
        tabFormat("Neimplementovano",SLOUPCU,RADKU-2,MIST_MANTIS-2,MIST_CHARAKT);
        
        Io.writeLn("==X05b END==");
    }// main() END /////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////
    
    static int statTypFce;
    static double statPocUhel,statKrokFce;
    
    static void tabFceInit (int typFce, double pocUhel, double krokFce){////////
        // POZOR - nelokalni staticke promenne
        statTypFce = typFce;
        statPocUhel = (2*Math.PI/360)*pocUhel;
        statKrokFce = (2*Math.PI/360)*krokFce;
    }// tabFceInit() END ///////////////////////////////////////////////////////
    
    static double tabFce (int krok){////////////////////////////////////////////
        // POZOR - nelokalni staticke promenne
        double vysledek;
        switch(statTypFce){
            case 1:
                vysledek = Math.sin(statPocUhel+(statKrokFce*krok)); 
                break;
            case 2:
                vysledek = Math.cos(statPocUhel+(statKrokFce*krok));    
                break;
            default:
                vysledek = 0.;
                break;
        }// switch
        return(vysledek);
    }// tabFce() END ///////////////////////////////////////////////////////////
    
    static boolean tabFormat (String tabNadpis, int sloupcuTab, int radkuTab,///
                              int mistMantisy, int mistCharakteristiky){
        // Jen lokalni promenne
        boolean vysledek=true;
        int krok;
        final int sirkaTab=sloupcuTab*(3+1+1+1+mistMantisy+1+1+mistCharakteristiky);
        // kontrola vstupnich parametru
        while(true){
            if(sloupcuTab > 6 || radkuTab > 10){
                vysledek = false;
                break;
            }
        ramTab(sirkaTab);
        hlavickaTab(tabNadpis,sirkaTab);
        ramTab(sirkaTab);
        // tisk tabulky
        krok = 0;
        for(int i = 1; i <= radkuTab; i++){
            for(int j = 1; j <= sloupcuTab; j++){
                Io.write(" | ");
                Io.write(tabFce(krok),mistMantisy,mistCharakteristiky);
                krok++;
            }// vnitrni for() END
            Io.writeLn(" |");
        }// vnejsi for() END
        ramTab(sirkaTab);
        break;    
        }// while() END
        return (vysledek);
    }// tabFormat() END ////////////////////////////////////////////////////////
    
    static void ramTab (int sirkaTab){//////////////////////////////////////////
       // Jen lokalni promenne
        Io.write(" |");
        for(int i = 0; i < (sirkaTab-2); i++)
            Io.write("-");
        Io.write("-|\n");
    }// ramTab() END ///////////////////////////////////////////////////////////
    
    static void hlavickaTab (String nadpisTab, int sirkaTab){///////////////////
        // Jen lokalni promenne
        if(nadpisTab.length() > sirkaTab-5) return;
        Io.write(" | " + nadpisTab);
        for(int i = 0; i < (sirkaTab - nadpisTab.length() - 2); i++)
            Io.write(" ");
        Io.writeLn("|");
    }// hlavickaTab() END //////////////////////////////////////////////////////
    
}// X05b class END ============================================================
