/*
 * A0B36PRI_091026_05  "PROGRAMOVANI"  08.07.2009 
 *   
 * Prednaska 05 - proceduralni programovani
 *
 * Vypocet urciteho integralu fce sinus(x) metodou lichobezniku
 * (Integral sin(x)=[-cos(x)]<alfa,beta>
 *  pr. Integral sin(x)<0,90>=[-cos(x)]<0,90>=-cos(90)-(-cos(0))=0+1=1;
 *  
 */

package a0b36pri_091026_05;

public class X05c {//=========================================================

    ////////////////////////////////////////////////////////////////////////////
    public static void main(String[] args) {//////////////////////////////
        double vysledek;
        // integral{sin(x)dx}<0,180> = 2

        Io.writeLn("==X05c END==");
       
        Io.writeLn("Vypocet urciteho integralu f(x)=integral{sin(x)dx}");
        Io.writeLn("==================================================");
        vysledek = integralSin(0,180,1000);
        Io.write("vysledek = ");
        Io.writeLn(vysledek,4);
        vysledek = integralSin(180,360,1000);
        Io.write("vysledek = ");
        Io.writeLn(vysledek,4);
        
        Io.writeLn("==X05c END==");
    }// main() END ///////////////////////////////////////////////////////////// 
    ////////////////////////////////////////////////////////////////////////////
    
    ////////////////////////////////////////////////////////////////////////////
    // Zadani:
    //      Vypocet urciteho integralu fce sin(x)
    // Vstup:
    //      pocatecni a koncovy uhel, pocet kroku
    // Vystup:
    //      integral fce sinus na int <pocUhel,koncUhel> 
    //
    static double integralSin (double pocUhel, double koncUhel, double pocetKroku){
      pocUhel = (2*Math.PI/360)*pocUhel;
      koncUhel = (2*Math.PI/360)*koncUhel;
      double krok = (koncUhel - pocUhel)/pocetKroku;
      double integral = 0;
      for(double i=pocUhel; i < (koncUhel-krok); i = i + krok){
          integral = integral + ((Math.sin(i)+Math.sin(i+krok))*krok)/2;
      }
      return(integral);
    }// integralSin() END //////////////////////////////////////////////////////
    
}// X05c class END ============================================================
