/*
 * A0B36PRI_091026_05  "PROGRAMOVANI"  08.07.2009 
 *   
 * Prednaska 05 - proceduralni programovani
 *
 * Vypocetni program s jednoduchou volbou prikazu co pocitat nebo zda koncit,
 * nalezenim vypocetni fce, vstupem parametru vypoctem a vystupem vysledku.
 *
 */

package a0b36pri_091026_05;

public class X05g {//=========================================================

    ////////////////////////////////////////////////////////////////////////////
    public static void main(String[] args) {//////////////////////////////
        int cmd = 0;
        Io.writeLn("==X05g==");

        while (true) {
            cmd = getCommand();
            switch (cmd) {
                case 1:
                    // vypocet obsahu obdelniku
                    //Io.writeLn("Obdelnik");
                    cmdObdelnik();
                    break;
                case 2:
                    // vypocet obsahu kruhu
                    //Io.writeLn("Kruh");
                    cmdKruh();
                    break;
                default: {
                    // tisk konec programu
                    Io.writeLn("Konec programu");
                    Io.writeLn("==X05g END==");
                    return;
                }
            }// switch() END
        }// while() END
    }// main() END /////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    static int getCommand() {////////////////////////////////////////////////
        // Vstup a vyhodnoceni prikazu
        while (true) {
            Io.writeLn("Zadej prikaz:");
            Io.writeLn("Obsah obdelniku = 1, ObsahKruhu = 2, Konec = 3");
            Io.writeLn("Prikaz = ");
            int cmd = Io.read(0);
            switch (cmd) {
                case 1:
                case 2:
                case 3:
                    return (cmd);
                default:
                    Io.writeLn("==Neznamy prikaz==");
                    break;
            }// switch() END
        }// while() END
    }// getCommand() END ///////////////////////////////////////////////////////

    static void cmdObdelnik() {//////////////////////////////////////////////////
        // Akce "Obdelnik"
        // Vstup dat
        int a = prectiKladnyInt("a=");
        int b = prectiKladnyInt("b=");
        // Vypocet
        int p = obsahObdelniku(a, b);
        // Vystup dat
        vypisInt("Obsah obdelniku = ", p);
    }// cmdObdelnik() END //////////////////////////////////////////////////////

    static void cmdKruh() {/////////////////////////////////////////////////////
        // Akce "Kruh"
        // Vstup dat
        double r = prectiKladnyDouble("r=");
        // Vypocet
        double p = obsahKruhu(r);
        // Vystup dat
        vypisDouble("Obsah kruhu = ", 4, p);
    }// cmdKruh() //////////////////////////////////////////////////////////////

    static int prectiKladnyInt(String napis) {//////////////////////////////////
        // Vstup dat (kladne cele cislo)
        int x = 0;
        while (true) {
            Io.writeLn("Zadej kladne cislo");
            Io.writeLn(napis);
            x = Io.read(x);
            if (x < 0) {
                Io.writeLn("Chyba");
                continue;
            }
            break;
        }
        return (x);
    }// prectiKladnyInt() END //////////////////////////////////////////////////

    static double prectiKladnyDouble(String napis) {////////////////////////////
        // Vstup dat (kladne racionalni cislo
        double d = 0;
        while (true) {
            Io.writeLn("Zadej kladne cislo");
            Io.writeLn(napis);
            d = Io.read(d);
            if (d < 0) {
                Io.writeLn("Chyba");
                continue;
            }
            break;
        }
        return (d);
    }// prectiKladnyDouble() END ///////////////////////////////////////////////

    static int obsahObdelniku(int a, int b) {
        // Vypocet 
        int obsahObdelniku = a * b;
        return (obsahObdelniku);
    } // obsahKruhu() END ///////////////////////////////////////////////////////

    static double obsahKruhu(double r) {/////////////////////////////////////////
        // Vypocet 
        double obsahKruhu = 2 * Math.PI * r;
        return (obsahKruhu);
    }// obsahKruhu() END ////////////////////////////////////////////////////////

    static void vypisInt(String napis, int x) {//////////////////////////////////
        // Vystup dat (cele cislo s popisem)
        Io.write("=== ");
        Io.write(napis + x);
        Io.writeLn(" ===\n");
        return;
    }// vypisInt() END /////////////////////////////////////////////////////////

    static void vypisDouble(String napis, int pocetMist, double hodnota) {///////
        // Vystup dat (racionalni cislo s popisem a omezenim platnych mist)
        Io.write(">>> ");
        Io.write(napis);
        Io.write(hodnota, pocetMist);
        Io.writeLn(" <<<\n");
        return;
    }// vypisDouble() END //////////////////////////////////////////////////////
}// X05g class END ============================================================
