/*
 * A0B36PRI_091123_08  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 08 - Soubory - zaklady
 *
 *  Soubory - Zapis/cteni pole objektu (zapis/cteni pole vcelku)
 * 
 */

package a0b36pri_091123_08;
import java.io.*;

public class X09i {
   
  public static void main(String[] args) throws IOException,ClassNotFoundException {
    System.out.println("===X09k===");
    Osoba1[] osoby = new Osoba1[8];
    osoby[0] = new Osoba1("Karel","1234",30,5000);
    osoby[1] = new Osoba1("Anna", "4567", 45, 6000);
    // osoby[2] - no object
    osoby[3] = new Osoba1("Hugo", "9999", 50, 8000);
    
    System.out.println("Zapis pole objektu");
    File f=new File("Osoby4.xxx");
    // ==>Zalozeni a Otevreni souboru pro ZAPIS
    //    Pokud jiz soubor existuje, jeho data se ztrati
    FileOutputStream fos = new FileOutputStream(f);
    ObjectOutputStream oos = new ObjectOutputStream(fos);
    oos.writeObject(osoby);
    oos.close();
  
    // ==>Cteni ze souboru (sekvencni /postupny)
    //    Predpoklad:
    //       - typ objektu v souboru je znamy (zde Osoba)
    //       - pocet objektu v souboru neznamy   
    System.out.println("Cteni pole objektu");    
    Osoba1[] seznam;
    FileInputStream fis = new FileInputStream(f);
    ObjectInputStream ois = new ObjectInputStream(fis); 
    seznam = (Osoba1[])ois.readObject();
    ois.close();
    
    for(int i = 0; i < seznam.length; i++){
        if(seznam[i] != null){
            System.out.println(seznam[i].getJmeno() + " : " + seznam[i].getTelefon() + " : " +              seznam[i].getVek() + " : " + seznam[i].getPlat());
        }// if() END
    }// for() END
    System.out.println("Delka precteneho pole objektu = "+seznam.length);
    System.out.println("===X09k END===");    
  }// main() END
    
}// X09i class END

class Osoba1 implements Serializable{//-----------------------------------------
  static int pocetObjektu=0;
  String jmeno;
  String telefon;
  int vek;
  int plat=0;

  public Osoba1 (String jmeno, String telefon, int vek, int plat){
    this.pocetObjektu++;
    this.jmeno=jmeno;
    this.telefon=telefon;
    this.vek=vek;
    this.plat=plat;
  }// Osoba constructor END

  String getJmeno(){
    return(this.jmeno);
  }// getJmeno() END

  String getTelefon(){
    return(this.telefon);
  }// getTelefon() END

  int getVek(){
    return(this.vek);
  }// getVek() END

  int getPlat(){
    return(this.plat);
  }// getPlat() ENd

  void setPlat(int plat){
    this.plat=plat;
  }// setPlat() END

}// Osoba1 class END------------------------------------------------------------
