/*
 * A0B36PRI_091123_08  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 08 - Soubory - zaklady
 *
 * Soubory - Zapis/cteni textovych souboru
 * 
 */

package a0b36pri_091123_08;
import java.io.*;
import java.util.*;

public class X09j {
  public static void main(String[] args) throws IOException{

    //=(1)======= write/read (pro textove soubory) ============================
    System.out.println("==Zapis/cteni typu String (textove promenne)");
    System.out.println("==(1)==== zapis/cteni int jako String ========");
    // ==> Zalozeni zastupne promenne typu File
    File f1=new File("c.txt");
    // ==>Zalozeni a Otevreni souboru pro ZAPIS
    //    Pokud jiz soubor existuje, jeho data se ztrati
    FileWriter fw1=new FileWriter(f1);
    BufferedWriter bw1=new BufferedWriter(fw1);
    // ==>Zapis do souboru (sekvencni / postupny)
    for(int i=0;i<10;i++){
      //bw1.write(String.valueOf(i)+"\r\n"); // writeln() neni, pridat konec radku
      bw1.write(i+"\r\n");
    //fw.newLine();
    }// for() END
    // ==>Zapsani obsahu vyrovnavaci pameti <- BufferedReader
    // bw1.flush(); // nemusi byt
    // ==>Uzavreni souboru
    bw1.close();

    // ==>Otevreni souboru pro CTENI
    FileReader fr1=new FileReader(f1);
    BufferedReader br1=new BufferedReader(fr1);
    int x;
    String s;
    System.out.println("========= cteni String a konverse na int ========");
    // ==>Cteni ze souboru (sekvencni /postupny)
    while((s=br1.readLine()) != null){
      x = Integer.parseInt(s);
      System.out.println("Konverse String->int x=" + x);
    } // while END
    // ==>Uzavreni souboru
    br1.close();

    // ==>Otevreni souboru pro CTENI
    fr1 = new FileReader(f1);
    br1 = new BufferedReader(fr1);
    System.out.println("========= cteni String a BEZ konverse na int ========");
    // ==>Cteni ze souboru (sekvencni /postupny)
    while (true) {
      s = br1.readLine();
      if (s == null)
        break;
      x = Integer.parseInt(s);
      System.out.println("String s="+s + " int=" + x);
    } // while() END
    // ==>Uzavreni souboru
    br1.close();
    System.out.println("==(1)==== zapis/cteni int jako String END ========\n");
   //=(1) END=================================================================

   //=(2)======= write/read (pro textove soubory) ============================
   //=========== println / readln ============================================
   System.out.println("==Zapis/cteni typu String (textove promenne)");
   System.out.println("==(2)==== zapis/cteni int jako String ========");
   // ==> Zalozeni zastupne promenne typu File
   File f2 = new File("d.txt");
   // ==>Zalozeni a Otevreni souboru pro ZAPIS
   //    Pokud jiz soubor existuje, jeho data se ztrati
   FileOutputStream fos2 = new FileOutputStream(f2);
   PrintStream ps2 = new PrintStream(fos2);

   // ==>Zapis do souboru (sekvencni / postupny)
   for (int i = 0; i < 15; i++) {
     ps2.println(i);
   } // form() END
   // ==>Uzavreni souboru
   ps2.close();

   // ==>Otevreni souboru pro CTENI
   FileInputStream fi2 = new FileInputStream(f2);
   DataInputStream dis2 = new DataInputStream(fi2);
   String s2;
   System.out.println("========= cteni String a BEZ konverse na int ========");
   // WARNING dis.readLine() deprecated
   while ( (s2 = dis2.readLine()) != null) {
     System.out.println("String s2=" + s2);
   } // while() END
   // ==>Uzavreni souboru
   dis2.close();
   System.out.println("==(2)==== zapis/cteni int jako String END ========\n");
   //=(2) END=================================================================

   //=(3)======= write/read (pro textove soubory) ============================
   //=========== println / readln ============================================
   System.out.println("==Zapis/cteni typu String (textove promenne)");
   System.out.println("==(3)==== zapis print(), int jako String ========");
   System.out.println("========= cteni readLine() & stringTokenizer()===");
   // ==> Zalozeni zastupne promenne typu File
   File f3 = new File("e.txt");
   // ==>Zalozeni a Otevreni souboru pro ZAPIS
   //    Pokud jiz soubor existuje, jeho data se ztrati
   FileOutputStream fos3 = new FileOutputStream(f3);
   PrintStream ps3 = new PrintStream(fos3);
   // ==>Zapis do souboru (sekvencni / postupny)
   for (int i = 0; i < 15; i++) {
     ps3.print(i + " ");
   } // form() END
   ps2.close();

   // ==>Otevreni souboru pro CTENI
   FileReader fr3 = new FileReader(f3);
   BufferedReader br3 = new BufferedReader(fr3);
   StringTokenizer st;
   st = new StringTokenizer(br3.readLine(), " ,:");
   while (st.hasMoreTokens()) {
     System.out.println("String st=" + st.nextToken());
   }// while() END
   br3.close();
   System.out.println("==(3)==== zapis/cteni int jako String END ========\n");
   //=(3) END=================================================================
 }// main() END

}// X09j class END