/*
 * A0B36PRI_091214_12  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 12 - Trideni - zaklady
 *
 * Slucovani - Merging (slucovani dvou serazenych posloupnosti)
 * 
 */

package a0b36pri_091214_12;

public class X12e {//==========================================================
    
    public static void main(String[] args) {//---------------------------------
      int[] p = {1,2,8,9,12};
      int[] q = {2,3,5,11};
      System.out.println("====X12e====");
      System.out.println("===Merge===");
      tiskPole(p);
      tiskPole(q);
      int[] r = slucPole(p,q);
      tiskPole(r);
      System.out.println("===Merge END===");
      System.out.println("====X12e END====");
    }// main() END ------------------------------------------------------------
    
    static int[] slucPole (int[] a, int[] b) {//-------------------------------
      int[] c = new int[a.length + b.length];
      int ia = 0, ib = 0, ic = 0;
      while (ia < a.length && ib < b.length ){
        if (a[ia] < b[ib]) {
          c[ic++] = a[ia++];
        } else {
          c[ic++] = b[ib++];
        }
      }
      while (ia < a.length){
        c[ic++] = a[ia++];
      }
      while (ib < b.length){
        c[ic++] = b[ib++];
      }
      return(c);
    }// slucPole() END --------------------------------------------------------

    static void tiskPole (int[] p){//------------------------------------------
      for(int i = 0; i < p.length; i++){
        System.out.print(p[i]+" ");
      }
      System.out.println("");
    }// tiskPole() END --------------------------------------------------------

}// X12e class END ============================================================
