/*
 * A0B36PRI_090921_02  "PROGRAMOVANI"  12.07.2009
 *   
 * Prednaska 02 - promenne,operatory,vystup,vstup
 * 
 * - Promenne
 * - Operatory
 * 
 */

package a0b36pri_091005_02;

public class X02c {
  String s1;
  /**
   * Test vars, static integer type
   */
  static int i=50, j=60;
  /**
   * Constant definition, note: "final" keyword
   */
  static final int MAX_HEIGHT=300;
  /**
   * Test var, note: "$" symbol is valid identifier  character
   */
  static int j$4;

  // all Java vars type are with sign !!
  static byte  b=10;           // 1 byte     (byter)0
  static short sh=50;          // 2 bytes    (short)0
  static int   it=200;         // 4 bytes     0
  static long  lg=300;         // 8 bytes     0L
  static String st="12ABC";

  static char ch='A';           // 2 bytes   '\u0000' (null)

  static float fl=1.0e3f;       // 4 bytes    0.0f
  static double db=3.45678e2;   // 8 bytes    0.0d

  static boolean b0=false;
  static boolean b1=true;       // 1 byte
  static boolean b2=false;     // FALSE is error

  /**
   * main function
   * @param args unused now
   * note: String[] args are obligatory !!!
   */
  public static void main(String[] args) {
    int ii;
    // Automatic casting
    db=it;
    // Forced casting
    it=(int)db;
    it=(int)ch;
    // Impossible casting - inconverible types
    //it=(int)bl;

    // Arithmetic operators
    it=it+it;
    it=it-it;
    it=it*it;
    it=it/3;
    it=it%2;  //division remainder
    it++;
    it--;

    // Logical operators
    b1=true;
    b2=false;
    b0=b1&&b2;     // and
    System.out.println(b0);
    b0=b1||b2;     // or
    System.out.println(b0);
    b0=!b1;        // not
    System.out.println(b0);

    // Bitwise operators
    int i0,i1,i2;
    i1=0xffff;
    i2=0x0003;
    i0=i1&i2;       // and
    System.out.println(i0);
    i1=0x0000;
    i2=0x0007;
    i0=i1|i2;       // or
    System.out.println(i0);
    i1=0x00ff;
    i2=0x00fe;
    i0=i1^i2;       // xor
    System.out.println(i0);
    i1=0xffffff00;
    i0=~i1;         // not
    System.out.println(i0);

    // Shift operators
    i1=0x0007;
    i0=i1>>>1;       // logical shift right, positive number
    System.out.println(i0);
    i1=0x0007;
    i0=i1>>1;        // arithmetic shift right, positive number
    System.out.println(i0);
    i1=0xffffffff;   // -1
    System.out.println(i0);
    i0=i1>>>1;       // logical shift right, negative number
    System.out.println(i0);
    i1=0xffffffff;   // -1
    i0=i1>>1;        // arithmetic shift right, negative number
    System.out.println(i0);

    // Relational operators
    i1=5;
    i2=10;
    b0=i1>i2;         // Greater than
    System.out.println(b0);
    b0=i1>=i2;        // Greater than or equal
    System.out.println(b0);
    b0=i1<i2;         // Less than
    System.out.println(b0);
    b0=i1<=i2;        // Less than or equal
    System.out.println(b0);
    b0=(i1==i2);      // Equal
    System.out.println(b0);
    b0=(i1!=i2);      // Not equal
    System.out.println(b0);
  }// main() END
}// X02c class END

