/*
 * A0B36PRI_091019_04  "PROGRAMOVANI"  30.06.2009
 *   
 * Prednaska 04 - metody (procedury a funkce)
 *
 */

package a0b36pri_091019_4;
import java.util.*;

public class X04e {
    static {Locale.setDefault(Locale.US);}
    
    public static void main(String[] args) {
    // Uloha: Opakovany vypocet ruznych vztahu ze vstupnich parametru.
    // Vypocetni vztah se voli pokynem z klavesnice
    // kontrola vstupnich parametru a kontrola podminky pro ukonceni vypoctu
    // Pseudokod:
    // CyklusStart:
    //      vstup povelu co pocitat
    //      kdyz(povel konec programu) jdi na Konec
    //      vetveni programu pro vypocet zvoleneho vztahu
    //        VypocetZvolenehoVztahu:
    //          tisk: napovedny text - co se bude pocitat
    //          vstup parametru pro vypocet
    //          kdyz(nespravne vstupni param)
    //              tisk: Chyba vstupu            
    //              jdi na VypocetZvolenehoVztahu    
    //          vypocet hodnot
    //          vystup hodnot
    //          jdi na CyklusStart
    //   CyklusEnd: 
    // Konec:
    //      Ukonci program
    //
    //  Reseni algoritmu v Jave:
        int povel=0;
        System.out.println("===X04e===");
        while(true){
            tiskMenu();
            povel = ctiPovel();
            switch(povel){
                case 1:
                   obsahuObdelniku(); 
                   break;
                case 2:
                   obsahuKruhu();
                   break;
                case 3:
                   System.out.println("Konec programu"); 
                   System.out.println("===X04e===");
                   return;
                default:
                   System.out.println("Neznamy prikaz"); 
                   break;
            }// switch() END
        }// while() END
    }// main() END
    
    static void tiskMenu (){
        System.out.println("1 = obdelnik, 2 = kruh, 3 = konec");
    }// tiskMenu() END
    
    static int ctiPovel(){
        Scanner read = new Scanner(System.in);
        int povel;
        System.out.println("Zadej povel p=");
        povel = read.nextInt();
        return(povel);
    }// ctiPovel() END
    
    static void obsahuObdelniku(){
        System.out.println("Obsah obdelniku");
    }//obsahuObdelniku() END
    
    static void obsahuKruhu(){        
        System.out.println("Obsah kruhu");
    }// obsahKruhu() END
    
}// X04e class END
