
/*
 * X08e.java       27.11.2008
 *
 * Pocitani vzniklych/zaniklych objektu, pole objektu, finalizer
 */

package a0b36pri_091116_07a;

public class X08e {
    
    public static void main(String[] args) {
        Majitel[] majitele=new Majitel[10];
        majitele[0] = new Majitel("Novak","Porsche");
        majitele[1] = new Majitel("Dvorak","BMW");
        majitele[2] = new Majitel("Pecena","Maybach");
        majitele[7] = new Majitel("Stanek","Porsche");
        
        // Najdi majitele porsche
        for(int i = 0; i < majitele.length; i++){
            if(majitele[i] != null){
                if(majitele[i].getAutomobil().equalsIgnoreCase("Porsche")){
                    System.out.println("Porsche vlastni "+majitele[i].getJmeno());
                }
            }
        }// for() END
        
        System.out.println("Pocet majitelu aut = "+Majitel.pocetMajitelu());
        
        // Dvorak prodal auto
        for(int i = 0; i < majitele.length; i++){
            if(majitele[i] != null && majitele[i].getJmeno().equalsIgnoreCase("Dvorak")){
                // Pozor: && -> zkracene vyhodnocovani
                //        &  -> uplne vyhodnocovani
                majitele[i].setAutomobil("");
            }
        }// for() END
        
        // Vyradime Dvoraka z evidence
        for(int i = 0; i < majitele.length; i++){
            if(majitele[i] != null && majitele[i].getAutomobil().equalsIgnoreCase("")){
                majitele[i] = null;
            }
        }// for() END
        
        // Aktualizujeme pocetMajitelu
        System.runFinalization();
        System.gc();
        System.out.println("Pocet majitelu aut = "+Majitel.pocetMajitelu());
        // Nebo spocitame obsazene polozky pole majitele{}

        int n=0;
        for(int i = 0; i < majitele.length; i++)
            if(majitele[i] != null) n++;
        System.out.println("Pocet majitelu aut = "+Majitel.pocetMajitelu());
        
    }// main() END

}// X08e class END

class Majitel{
    static int pocetMajitelu=0;
    String jmeno="";
    String automobil="";
    
    public Majitel (String jmeno, String automobil){
        pocetMajitelu++;
        this.jmeno = jmeno;
        this.automobil = automobil;
    }// constructor END
    
    protected void finalize() throws Throwable{
        pocetMajitelu --;
        System.out.println("Konce majitele");  // Ladici tisk
        super.finalize();
    }// finalize()END (finalize() everriding - prekryti)

    static int pocetMajitelu(){
        return(pocetMajitelu);
    }// pocetMajitelu() END
    
    String getJmeno(){
        return(this.jmeno);
    }// getJmeno() END
    
    String getAutomobil(){
        return(this.automobil);
    }// getAutomobil() END
        
    void setAutomobil(String automobil){
        this.automobil = automobil;
    }// setAutomobil() END
    
}// Majitel class END