/*
 * A0B36PRI_091116_07a  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 07 - Objektove programovani
 *
 * Pole objektu, referencni promenna formalnim parametrem a navratovou hodnotou
 *
 */


package a0b36pri_091116_07a;

public class X08f {//===========================================================
    
    public static void main(String[] args) {
        Osoba1[] seznam = new Osoba1[10];
        seznam[0] = new Osoba1("Jana","1111");
        seznam[2] = new Osoba1("Karel","2222");
        seznam[5] = new Osoba1("Pavel","4444");
        // Tisk seznamu
        for(int i = 0; i < seznam.length; i++ ){
            if(seznam[i] != null){
                System.out.println(seznam[i].getJmeno()+" "+seznam[i].getTelefon());
            }
        }// for() END
        
        Osoba1 o1 = new Osoba1("Hugo","5555");
        if(vlozDoSeznamu(o1,seznam)){
            System.out.println("Osoba "+ o1.getJmeno()+" vlozena do seznamu");
        }
        
        Osoba1 o2;
        if((o2=najdiVSeznamu("Hugo",seznam)) != null){
            System.out.println("Nalezen: "+o2.getJmeno()+" Tel: "+o2.getTelefon());
        }
        
    }// main() END

    static boolean vlozDoSeznamu (Osoba1 osoba, Osoba1[] seznam){
       for(int i = 0; i < seznam.length; i++){
            if(seznam[i] == null){
                seznam[i] = osoba;
                return(true);
            }
        }// for() END
        return(false);
    }// vlozDoSeznamu
    
    static Osoba1 najdiVSeznamu (String jmeno, Osoba1[] seznam){
        for(int i = 0; i < seznam.length; i++){
            if(seznam[i].getJmeno().equalsIgnoreCase(jmeno)){
                return(seznam[i]);
            }
        }
        return(null);
    }// najdiVSeznamu() END
    
}// X08f class END =============================================================

class Osoba1 {//=================================================================
    String jmeno;
    String telefon;
    
    public Osoba1 (String jmeno, String telefon){
        this.jmeno = jmeno;
        this.telefon = telefon;
    }// constructor END

    void setTelefon (String telefon){
        this.telefon = telefon;
    }// setTelefon() END

    String getJmeno (){
        return(this.jmeno);
    }// getJmeno
    
    String getTelefon (){
        return(this.telefon);
    }// getTelefon() END
    
}// Osoba class END ============================================================
