/*
 * A0B36PRI_091123_08  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 08 - Soubory - zaklady
 *
 *  FileInputStream, FileOutputStream - cteni/zapis byte
 * 
 */

package a0b36pri_091123_08;
import java.io.*;

public class X09b {
    
    public static void main(String[] args) throws IOException {
        // === Zapis pole int[]
        int[] p = {1,2,3,4,5};
        File f = new File("test1.xxx");
        FileOutputStream fos = new FileOutputStream(f);
        for(int i = 0; i < p.length; i++){
            fos.write(p[i]);
        }
        fos.close();

        // == Cteni pole int[]
        FileInputStream fis = new FileInputStream("test1.xxx");
        int delka = fis.available();
        int[] q = new int[delka];
        for(int i = 0; i < delka; i++){
            q[i] = fis.read();
            System.out.println("g[i] = "+q[i]);
        }
        int x = fis.read();     // EOF - End Of File - vraci -1, nevyvola vyjimku !!
        for(int i = 0; i < 10; i++){
           System.out.println("EOF = "+fis.read());
        }
        fos.close();
        
        // === Kopie souboru ===
        fis = new FileInputStream("test1.xxx");
        fos = new FileOutputStream("test3.xxx");
        while(fis.available() > 0){
            fos.write(fis.read());      // Vytvor kopii souboru test1.xxx
        }
        fis.close();
        fos.close();
        
        FileInputStream fis_orig = new FileInputStream("test1.xxx");
        FileInputStream fis_kopie = new FileInputStream("test3.xxx");
        while(fis_kopie.available() > 0){
            System.out.println("test1 = "+fis_orig.read()+" | "+"test2 = "+fis_kopie.read());
        }
            
        // === Zapis casti pole ===
        byte[] r = {1,2,3,4,5,6,7,8,9,10};
        fos = new FileOutputStream("test4.xxx");
        fos.write(r,3,4);
        fis = new FileInputStream("test4.xxx");
        while(fis.available() > 0){
            System.out.println(fis.read());
        }
        fos.close();
        
        // ==== Vyvolani vyjimky ===
        // "Nezname jmeno souboru" - FileNotFoundException
        //fis = new FileInputStream("neznam.xxx");//Neznamy soubor 
        //fos = new FileOutputStream("x:\test.xxx");//Neznama cesta
        
    }// main() END
    
}// X09b class END
