/*
 * A0B36PRI_091123_08  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 08 - Soubory - zaklady
 *
 *  ObjectInputStream, ObjectOutputStream - cteni/zapis int[] (Object)
 *  Vyjimka osetrena mimo metody (pripadna vyjmka je vyhozena z metody)S
 * 
 */

package a0b36pri_091123_08;
import java.io.*;

public class X09h {
    
    public static void main(String[] args) throws Exception {
        double[] d = {12.34, 23.45, 34.56, 45.67, 56.78};
        String jmenoSouboru = "test9.xxx";
        String vysledek;
        System.out.println("(1)-Zapis double[] do souboru");
        try{
            zapisPoleDouble(jmenoSouboru,d);
        }
        catch (Exception e) {
            System.out.println(e.getMessage());
            System.exit(1);
        }
        System.out.println("(1)-Zapis double[] Ok:\n");

        System.out.println("(2)-Cteni double[] ze souboru");
        double[] dd = null;
        //jmenoSouboru = "xxx.yyy";
        try{
            dd=cteniPoleDouble(jmenoSouboru);
        }
        catch (Exception e) {
            System.out.println(e.getMessage());
            //System.exit(1);
            throw e;
        }
        for(int i = 0; i < dd.length; i++){
            System.out.println("dd[i] = "+dd[i]);
        }
        System.out.println("(2)-Cteni double[] Ok:\n");
        
    }// main() END
    
    static void zapisPoleDouble (String jmenoSouboru, double[] p) throws IOException{
        FileOutputStream fos = new FileOutputStream(new File(jmenoSouboru));
        ObjectOutputStream oos = new ObjectOutputStream(fos);
        oos.writeObject(p);
        oos.close();
        return;
    }// zapisPoleDouble() END
    
    static double[] cteniPoleDouble (String jmenoSouboru) 
                                     throws IOException, ClassNotFoundException {
        String vysledek = null;
        FileInputStream fis = new FileInputStream(new File(jmenoSouboru));
        ObjectInputStream ois = new ObjectInputStream(fis);
        double[] d = (double[])ois.readObject();
        ois.close();
        return(d);
   }// String cteniPoleDouble() END
    
}// X09f class END
